(define-module (ui xkb ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

;;; logic

(define (ui- action)
  (catch/message
    (lambda()
      (woo-write "/xkb" action #t  'layout (form-value "layout"))
      (ui-read))))

(define (ui-apply)
  (catch/message
    (lambda()
      (woo-write "/xkb"
		 'submit #t
		 'grp (form-value "grp")
		 'model (form-value "model")
		 'language (form-value "language")))))

(define (ui-add)
  (form-replace "/xkb/avail_layout"))

(define (ui-up) (ui- 'up))
(define (ui-down) (ui- 'down))
(define (ui-remove) (ui- 'remove))

(define (ui-read)
  (form-update-enum "layout" (woo-list "/xkb/current_layout" 'language (form-value "language")))
  (form-update-value-list
    '("model" "grp" "layout")
    (woo-read-first "/xkb")))

(define (init)
  (form-update-enum "model" (woo-list "/xkb/avail_model" 'language (form-value "language")))
  (form-update-enum "grp" (woo-list "/xkb/avail_grp" 'language (form-value "language")))
  (form-bind "up_button" "click" ui-up)
  (form-bind "down_button" "click" ui-down)
  (form-bind "add_button" "click" ui-add)
  (form-bind "remove_button" "click" ui-remove)
  (form-bind "apply_button" "click" ui-apply)
  (ui-read))
