(define-module (ui xkb avail_layout ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator algo)
    :export (init))

(define (ui-cancel)
  (form-replace "/xkb"))

(define (ui-ok)
  (catch/message
    (lambda()
      (woo-write "/xkb/avail_layout" 'variant (form-value "variant") 'language (form-value "language"))
      (form-replace "/xkb"))))

(define (ui-read . name)
  (let* ((name (if (pair? name) (car name) (form-value "name")))
	 (data (woo-list "/xkb/avail_variant" 'name name 'language (form-value "language")))
	 (variant (woo-get-option (cond-car data) 'name #f)))
    (form-update-enum "variant" data)
    (and variant (form-update-value "variant" variant))))

(define (init)
  (let* ((data (woo-list "/xkb/avail_layout" 'language (form-value "language")))
	 (name (woo-get-option (cond-car data) 'name #f)))
    (form-update-enum "name" data)
    (and name (ui-read name)))
  (form-bind "name" "change" ui-read)
  (form-bind "ok" "click" ui-ok)
  (form-bind "cancel" "click" ui-cancel))
