(document:surround "/std/frame")

;;; ui

width 650
height 400

(gridbox columns "0;100"
         (label text (_ "Country:") align "right")
         (combobox name "name")
         (label (_ "Available layouts:") colspan 2)
         (listbox colspan 2 name "variant")

         (label colspan 2)

         (spacer)
         (hbox align "left"
               (button (_ "Add") name "ok")
               (button (_ "Cancel") name "cancel")))

;;; logic
(define (ui-cancel)
  (document:end #f))

(define (ui-ok)
  (catch/message
    (lambda()
      (woo-write "/xkb/avail_layout" 'variant (form-value "variant"))
      (document:end #t))))

(define (ui-read . name)
  (let* ((name (if (pair? name) (car name) (form-value "name")))
	 (data (woo-list "/xkb/avail_variant" 'name name))
	 (variant (woo-get-option (cond-car data) 'name #f)))
    (form-update-enum "variant" data)
    (and variant (form-update-value "variant" variant))))

(define (ui-init)
  (let* ((data (woo-list "/xkb/avail_layout"))
	 (name (woo-get-option (cond-car data) 'name #f)))
    (form-update-enum "name" data)
    (and name (ui-read name)))
  (form-bind "name" "change" ui-read)
  (form-bind "ok" "click" ui-ok)
  (form-bind "cancel" "click" ui-cancel))

(document:root (when loaded (ui-init)))
