(document:surround "/std/frame")

;;; ui

(gridbox columns "0;100"
	 margin 20

	 (label text (_ "Layouts:") align "left" colspan 2)
	 (listbox colspan 2 name "layout")

	 (hbox align "left"
	       (button text (_ "Add") align "left" name "add_button")
	       (button text (_ "Remove") align "left" name "remove_button"))
	 (hbox align "right"
	       (button text (_ "Up") align "right" name "up_button")
	       (button text (_ "Down") align "right" name "down_button"))

	 (label colspan 2)

	 (label text (_ "Layout switching:") align "right")
	 (combobox name "grp")

	 (label text (_ "Model:") align "right")
	 (combobox name "model")

         (label colspan 2)

	 (spacer)
	 (button text (_ "Apply") align "left" name "apply_button"))

;;; logic

(define (ui- action)
  (catch/message
    (lambda()
      (woo-write "/xkb" action #t  'layout (form-value "layout"))
      (ui-read))))

(define (ui-apply)
  (catch/message
    (lambda()
      (woo-write "/xkb"
		 'submit #t
		 'update #t
		 'grp (form-value "grp")
		 'model (form-value "model")))))

(define (ui-add)
  (and (form-popup "/xkb/avail_layout")
       (ui-read)))

(define (ui-up) (ui- 'up))
(define (ui-down) (ui- 'down))
(define (ui-remove) (ui- 'remove))

(define (ui-read)
  (form-update-enum "layout" (woo-list "/xkb/current_layout"))
  (form-update-value-list
    '("model" "grp" "layout")
    (woo-read-first "/xkb")))

(define (ui-init)
  (form-update-enum "model" (woo-list "/xkb/avail_model"))
  (form-update-enum "grp" (woo-list "/xkb/avail_grp"))
  (form-bind "up_button" "click" ui-up)
  (form-bind "down_button" "click" ui-down)
  (form-bind "add_button" "click" ui-add)
  (form-bind "remove_button" "click" ui-remove)
  (form-bind "apply_button" "click" ui-apply)
  (ui-read))

(document:root (when loaded (ui-init)))
